"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var Text_1 = __importDefault(require("@ilovepdf/ilovepdf-js-core/tasks/edit/Text"));
var ILovePDFFile_1 = __importDefault(require("../ILovePDFFile"));
var dotenv_1 = __importDefault(require("dotenv"));
var fs_1 = __importDefault(require("fs"));
var __1 = __importDefault(require(".."));
// Load env vars.
dotenv_1.default.config();
var instance = new __1.default(process.env.PUBLIC_KEY, process.env.SECRET_KEY);
var task = instance.newTask('editpdf');
task.start()
    .then(function () {
    var file = new ILovePDFFile_1.default('<FILE_PATH>');
    return task.addFile(file);
})
    .then(function () {
    var textElement = new Text_1.default({
        coordinates: { x: 100, y: 100 },
        dimensions: { w: 100, h: 100 },
        text: 'test',
    });
    return task.addElement(textElement);
})
    .then(function () {
    return task.process();
})
    .then(function () {
    return task.download();
})
    .then(function (data) {
    fs_1.default.writeFileSync('path/to/local/file_name.txt', data);
});
//# sourceMappingURL=edit.js.map