"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var __1 = __importDefault(require(".."));
var dotenv_1 = __importDefault(require("dotenv"));
var SignatureFile_1 = __importDefault(require("@ilovepdf/ilovepdf-js-core/tasks/sign/elements/SignatureFile"));
var Signer_1 = __importDefault(require("@ilovepdf/ilovepdf-js-core/tasks/sign/receivers/Signer"));
var ILovePDFFile_1 = __importDefault(require("../ILovePDFFile"));
// Load env vars.
dotenv_1.default.config();
var instance = new __1.default(process.env.PUBLIC_KEY, process.env.SECRET_KEY);
var task = instance.newTask('sign');
task.start()
    .then(function () {
    var file = new ILovePDFFile_1.default('<FILE_PATH>');
    return task.addFile(file);
})
    .then(function (file) {
    var signatureFile = new SignatureFile_1.default(file, [{
            type: 'signature',
            position: '300 -100',
            pages: '1',
            size: 28,
        }]);
    return signatureFile;
})
    .then(function (signatureFile) {
    var signer = new Signer_1.default('Diego Signer', 'invent@ado.com');
    signer.addFile(signatureFile);
    task.addReceiver(signer);
})
    .then(function () {
    return task.process();
})
    .then(function (response) {
    console.log(response);
});
//# sourceMappingURL=sign_file.js.map