"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var __1 = __importDefault(require(".."));
var fs_1 = __importDefault(require("fs"));
var dotenv_1 = __importDefault(require("dotenv"));
// Load env vars.
dotenv_1.default.config();
var instance = new __1.default(process.env.PUBLIC_KEY, process.env.SECRET_KEY);
var task = instance.newTask('split');
task.start()
    .then(function () {
    return task.addFile('<FILE_URL>');
})
    .then(function () {
    // Be sure that your PDF has minimum 2 pages.
    return task.process({ split_mode: 'ranges', ranges: '1-2,1-2,1' });
})
    .then(function () {
    return task.download();
})
    .then(function (data) {
    // Zip file.
    fs_1.default.writeFileSync('<FILE_PATH>', data);
});
//# sourceMappingURL=split.js.map